#include <SPI.h>
#include <Gamebuino.h>
#include "structs.h"
Gamebuino gb = Gamebuino();

// Coded by Drakker

typedef float float16;

extern const byte font3x5[];
extern const byte logo[] PROGMEM;

// Fixed play area, defaults to Gamebuino display size. Prevents weird effects on screens of other resolutions.
#define PLAY_AREA_LEFT 2 
#define PLAY_AREA_RIGHT 82
#define PLAY_AREA_TOP 2
#define PLAY_AREA_BOTTOM 48

// Shape of the play area: 10x8 bricks / Bricks related
#define BRICKS_NB_WIDTH 10
#define BRICKS_NB_HEIGHT 8
#define BRICK_THICKNESS 3
#define BRICK_WIDTH 8
#define BREAK_ANIMATION_FRAME -10

// Items parameters
#define ITEMS_FALL_SPEED 1
#define NB_ITEMS_MAX 8
#define NB_ROCKETS_MAX 3
#define NB_ROCKETS_SIMULTANEOUS_MAX 1
#define NB_ROCKETS_PER_ITEM 1
#define NB_LASERS_MAX 30
#define NB_LASERS_SIMULTANEOUS_MAX 6
#define NB_LASERS_PER_ITEM 10

// Bar/Player parameters
#define PLAYER_HEIGHT 44
#define BAR_MIN_WIDTH 9
#define BAR_MAX_WIDTH 24

// Status display related
#define STATUS_POS_X 66
#define STATUS_POS_Y 32

// Ball parameters
#define NB_BALLS_MAX 5
#define NB_ANGLES 12
#define MAX_VELO 1
#define MIN_VELO 0.3
#define BALL_VELO_ITEM_MOD 0.1

// Explosion parametera
#define NB_EXPLOSIONS_MAX 5
#define EXPLOSIONS_DURATION 6

// Level, will need a level loader in the future.
//char bricks[] = {
//  5,2,3,4,5,5,4,3,2,5,
//  3,2,3,100,1,1,1,100,2,3,
//  4,2,1,1,1,1,0,1,2,4,
//  3,2,4,1,4,0,1,4,2,3,
//  3,2,4,1,0,4,1,4,2,3,
//  4,2,1,0,1,1,1,1,2,4,
//  3,2,100,1,4,4,100,3,2,3,
//  1,2,3,4,5,5,4,3,2,1, };

//char bricks[] = {
//  4,4,4,4,4,4,4,4,4,4,
//  4,4,4,100,4,4,100,4,4,4,
//  4,4,4,4,4,4,4,4,4,4,
//  4,4,4,4,4,4,4,4,4,4,
//  4,4,4,4,4,4,4,4,4,4,
//  4,100,4,4,4,4,4,4,100,4,
//  4,4,4,4,4,4,4,4,4,4,
//  4,4,4,4,100,100,4,4,4,4, };

//char bricks[] = {
//  5,5,100,5,5,100,5,5,100,100,
//  5,5,5,5,5,5,5,5,100,100,
//  5,5,5,100,5,5,100,5,100,100,
//  100,5,5,5,5,100,5,5,100,100,
//  5,5,5,5,100,5,5,5,100,100,
//  5,5,5,100,5,5,100,5,100,100,
//  5,100,5,5,5,5,5,5,100,100,
//  5,5,5,5,5,100,5,5,5,100, };


////// Level, will need a level loader in the future.
//char bricksRow1[BRICKS_NB_WIDTH] = { 5,2,3,4,5,5,4,3,2,5 };
//char bricksRow2[BRICKS_NB_WIDTH] = { 3,2,3,100,1,1,1,100,2,3 };
//char bricksRow3[BRICKS_NB_WIDTH] = { 4,2,1,1,1,1,6,1,2,4 };
//char bricksRow4[BRICKS_NB_WIDTH] = { 3,2,4,1,4,6,1,4,2,3 };
//char bricksRow5[BRICKS_NB_WIDTH] = { 3,2,4,1,6,4,1,4,2,3 };
//char bricksRow6[BRICKS_NB_WIDTH] = { 4,2,1,6,1,1,1,1,2,4 };
//char bricksRow7[BRICKS_NB_WIDTH] = { 3,2,100,1,4,4,100,3,2,3 };
//char bricksRow8[BRICKS_NB_WIDTH] = { 1,2,3,4,5,5,4,3,2,1 };

// Level, will need a level loader in the future.
//char bricksRow1[BRICKS_NB_WIDTH] = { 5,2,3,4,5,5,4,3,2,5 };
//char bricksRow2[BRICKS_NB_WIDTH] = { 3,2,3,100,1,1,1,100,2,3 };
//char bricksRow3[BRICKS_NB_WIDTH] = { 4,2,1,1,1,1,6,1,2,4 };
//char bricksRow4[BRICKS_NB_WIDTH] = { 6,2,4,1,4,6,1,4,2,6};
//char bricksRow5[BRICKS_NB_WIDTH] = { 4,4,4,4,4,4,4,4,4,4 };
//char bricksRow6[BRICKS_NB_WIDTH] = { 4,4,4,4,4,4,4,4,4,4 };
//char bricksRow7[BRICKS_NB_WIDTH] = { 4,4,4,4,4,4,4,4,4,4 };
//char bricksRow8[BRICKS_NB_WIDTH] = { 4,4,4,4,4,4,4,4,4,4 };

//// Level, will need a level loader in the future.
char bricksRow1[BRICKS_NB_WIDTH] = { 4,108,4,108,4,108,4,108,4,108 };
char bricksRow2[BRICKS_NB_WIDTH] = { 0,0,0,0,0,0,0,0,0,0 };
char bricksRow3[BRICKS_NB_WIDTH] = { 0,2,4,2,0,0,2,4,2,0 };
char bricksRow4[BRICKS_NB_WIDTH] = { 0,2,100,2,0,0,2,100,2,0 };
char bricksRow5[BRICKS_NB_WIDTH] = { 6,5,4,4,6,6,4,4,5,6 };
char bricksRow6[BRICKS_NB_WIDTH] = { 0,1,1,1,0,0,1,1,1,0 };
char bricksRow7[BRICKS_NB_WIDTH] = { 0,1,4,1,4,4,1,4,1,0 };
char bricksRow8[BRICKS_NB_WIDTH] = { 0,1,4,1,0,0,1,4,1,0 };


char* bricks[BRICKS_NB_HEIGHT] = {
  bricksRow1,
  bricksRow2,
  bricksRow3,
  bricksRow4,
  bricksRow5,
  bricksRow6,
  bricksRow7,
  bricksRow8 };

// Blank logo for now
const byte PROGMEM logo[] =
{
  64, 1,
  B00000000, B00000000, B00000000, B00000000, B00000000, B00000000, B00000000, B00000000, };

// Sprites start here
const byte PROGMEM brick1_1[] = {
  8,3,
  B10101010,
  B00000001,
  B11111111, };  
const byte PROGMEM brick1_2[] = {
  8,3,
  B01010101,
  B10000001,
  B01111111, };

const byte PROGMEM brick2_1[] = {
  8,3,
  B10101010,
  B01010101,
  B11111111, };
const byte PROGMEM brick2_2[] = {
  8,3,
  B01010101,
  B10101011,
  B01111111, };

const byte PROGMEM brick3_1[] = {
  8,3,
  B10101010,
  B01111111,
  B11111111, };
const byte PROGMEM brick3_2[] = {
  8,3,
  B01010101,
  B11111111,
  B01111111, };

const byte PROGMEM brick4_1[] = {
  8,3,
  B10101010,
  B00011101,
  B11111111, }; 
const byte PROGMEM brick4_2[] = {
  8,3,
  B01010101,
  B10111001,
  B01111111, };
  
const byte PROGMEM brick5_1[] = {
  8,3,
  B10101010,
  B01110101,
  B11111111, };   
const byte PROGMEM brick5_2[] = {
  8,3,
  B01010101,
  B10101111,
  B01111111, };

const byte PROGMEM brick6_2[] = {
  8,3,
  B01010101,
  B10100101,
  B01111111, };

const byte PROGMEM brick6_21[] = {
  8,3,
  B10101010,
  B00000000,
  B01010101, }; 

const byte PROGMEM brickBomb_1[] = {
  8,3,
  B11111111,
  B10000001,
  B11111111, };
const byte PROGMEM brickBomb_2[] = {
  8,3,
  B11111111,
  B11000011,
  B11111111, };
const byte PROGMEM brickBomb_3[] = {
  8,3,
  B11111111,
  B11100111,
  B11111111, };
const byte PROGMEM brickBomb_4[] = {
  8,3,
  B11111111,
  B11111111,
  B11111111, };
  
const byte PROGMEM brickMine_1[] = {
  8,3,
  B11111111,
  B10011001,
  B11111111, };
const byte PROGMEM brickMine_2[] = {
  8,3,
  B11111111,
  B11011011,
  B11111111, };
const byte PROGMEM brickMine_3[] = {
  8,3,
  B11111111,
  B11111111,
  B11111111, };
const byte PROGMEM brickMine_4[] = {
  8,3,
  B11111111,
  B10111101,
  B11111111, };

const byte PROGMEM break1_1[] = {
  8,3,
  B00000000,
  B00000001,
  B01111111, };
const byte PROGMEM break1_2[] = {
  8,3,
  B11111111,
  B11111111,
  B11111111, }; 
const byte PROGMEM break2_2[] = {
  8,3,
  B01011010,
  B10100101,
  B01011010, }; 
const byte PROGMEM break3_2[] = {
  8,3,
  B00001010,
  B01010110,
  B01001100, };
const byte PROGMEM break4_1[] = {
  8,3,
  B00000000,
  B00000001,
  B01010010, };
const byte PROGMEM break4_2[] = {
  8,3,
  B01001010,
  B10010000,
  B00101000, };
const byte PROGMEM break5_2[] = {
  8,3,
  B00000000,
  B00000100,
  B00000000, };

const byte PROGMEM picWall1[] = {
  8,2,
  B11101011,
  B11111111, }; 
const byte PROGMEM picWall2[] = {
  8,2,
  B01010110,
  B11111111, };
  
const byte PROGMEM barSide1[] = {
  8,4,
  B01111111,
  B10100000,
  B11100000,
  B01111111, };
const byte PROGMEM barSide2[] = {
  8,4,
  B01111111,
  B11100000,
  B11111111,
  B01111111, };
  
const byte PROGMEM barMid1[] = {
  8,4,
  B11111111,
  B00000000,
  B00000000,
  B11111111, };
const byte PROGMEM barMid2[] = {
  8,4,
  B11111111,
  B00000000,
  B11111111,
  B11111111, };
  
const byte PROGMEM rocketSprite1[] = {
  8,3,
  B00011010,
  B11111101,
  B00011010, };
const byte PROGMEM rocketSprite2[] = {
  8,3,
  B00111000,
  B11110110,
  B00111000, };
  
const byte PROGMEM explosion[] = {
  16,12,
  B00110000, B00100000,
  B00011100, B01110000,
  B00001111, B10011000,
  B01111000, B00001100,
  B11000000, B00000111,
  B11000000, B0000110,
  B01100000, B00001100,
  B00100001, B1111000,
  B00110001, B10111100,
  B00100111, B00000111,
  B00101100, B00000000,
  B00111000, B00000000, };
  
  
const byte* wall[2];
const byte* brick1[2];
const byte* brick2[2];
const byte* brick3[2];
const byte* brick4[2];
const byte* brick5[2];
const byte* brick6[2];
const byte* brick100[2];
const byte* brick101[2];
const byte* brick102[2];
const byte* brick103[2];
const byte* brick104[2];
const byte* brick105[2];
const byte* brick106[2];
const byte* brick108[2];
const byte* brick109[2];
const byte* brick110[2];
const byte* brick111[2];
const byte* brick112[2];
const byte* brick113[2];
const byte* brick114[2];

const byte* break1[2];
const byte* break2[2];
const byte* break3[2];
const byte* break4[2];
const byte* break5[2];

const byte* barSide[2];
const byte* barMid[2];
const byte* rocket[2];



cursorStruct sdkfhsf = (cursorStruct) { -1, 0 };

playerStatsStruct playerStats = (playerStatsStruct) { 22,0,16,3,0,0,0 };

// See next comment.
ballStruct balls[NB_BALLS_MAX] = {
  { -1,0,0,0,0,0 },
  { -1,0,0,0,0,0 },
  { -1,0,0,0,0,0 },
  { -1,0,0,0,0,0 },
  { -1,0,0,0,0,0 }, };

// This seems stupid at first because NB_ITEMS_MAX should be the only thing you need to
// modify to change the number of items, but not having code to actually fill it reduces
// the program size.
itemStruct items[NB_ITEMS_MAX] = { 
  { -1, 0, 0 }, 
  { -1, 0, 0 },
  { -1, 0, 0 },
  { -1, 0, 0 },
  { -1, 0, 0 },
  { -1, 0, 0 },
  { -1, 0, 0 },
  { -1, 0, 0 }, };

// Same comment as before.
projectileStruct lasers[NB_LASERS_SIMULTANEOUS_MAX] = {
  { -1,-1 },
  { -1,-1 },
  { -1,-1 },
  { -1,-1 },
  { -1,-1 },
  { -1,-1 }, };

// Again, same comment as before.
projectileStruct rockets[NB_ROCKETS_SIMULTANEOUS_MAX] = {
  { -1,-1 }, };
  
// Same old comment as before.
explosionStruct explosions[NB_EXPLOSIONS_MAX] = {
  { -99,0,0 },
  { -99,0,0 },
  { -99,0,0 },
  { -99,0,0 },
  { -99,0,0 }, };
  
// Angles -- same damn old comment as before.
angleStruct angles[NB_ANGLES] = {
//  { 0.996194698092, 0.0871557427477 }, // 5 deg
//  { 0.984807753012, 0.173648177667 }, // 10 deg
//  { 0.965925826289, 0.258819045103 },
  { 0.939692620786, 0.342020143326 },
  { 0.906307787037, 0.422618261741 },
  { 0.866025403784, 0.5 },            //30 deg
  { 0.819152044289, 0.573576436351 },
  { 0.766044443119, 0.642787609687 },
  { 0.707106781187, 0.707106781187 }, // 45deg
  { 0.642787609687, 0.766044443119 },
  { 0.573576436351, 0.819152044289 },
  { 0.5, 0.866025403784 },            // 60deg
  { 0.422618261741, 0.906307787037 },
  { 0.342020143326, 0.939692620786 },
  { 0.258819045103, 0.965925826289 },
//  { 0.173648177667, 0.984807753012 },  // 80deg
//  { 0.0871557427477, 0.996194698092 }, // 85deg
};

boolean frame = 0;
boolean pause = false;
float ballAcceleration = 0.00001;

void spawnBall(ballStruct ballParams, boolean randomBall = 0) {
  char ballFound = -1;
  for (byte idx = 0; idx < NB_BALLS_MAX && ballFound == -1; idx++) {
    if (balls[idx].x == -1) { ballFound = idx; }
  }
  if (ballFound > -1) {
    if (randomBall) {
      char randomBallId = -1;
      for (byte idx = 0; idx < NB_BALLS_MAX && randomBallId == -1; idx++) {
        if (balls[idx].x != -1) { randomBallId = idx; }
      }
      balls[ballFound] = balls[randomBallId];
      randomBallId = balls[ballFound].angle; // Re-using the randomBallId variable for another purpose
      while (randomBallId == balls[ballFound].angle) {
        changeBallAngle(random(-5,6), ballFound); 
      }
    }
    else { balls[ballFound] = ballParams; }
  }
}

byte countBalls() {
  byte count;
  for (byte idx = 0; idx < NB_BALLS_MAX; idx++) { 
    if (balls[idx].x > -1) { count++; }
  }
  return count; 
}

void moveBalls() {
  boolean bounceUp;
  boolean bounceDown;
  boolean bounceRight;
  boolean bounceLeft;
  
  cursorStruct brickHitX;
  cursorStruct brickHitY;
  
  for (byte idx = 0; idx < NB_BALLS_MAX && balls[idx].x != -1; idx++)
  {
    if (balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y) >= PLAY_AREA_BOTTOM && idx != 0) { balls[idx].x = -1; }
    else {
      bounceRight = 0;
      bounceLeft = 0;
      bounceUp = 0;
      bounceDown = 0;
      
      brickHitX = (cursorStruct) { -1, 0 };
      brickHitY = (cursorStruct) { -1, 0 };
      
      // Ball X collision detection
      if (balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x) >= PLAY_AREA_RIGHT) { bounceRight = 1;  }
      else if (balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x) <= PLAY_AREA_LEFT) { bounceLeft = 1; }
      else {
        brickHitX = isThereABrickHere(floor(balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x)), floor(balls[idx].y));
        if (brickHitX.x > -1) {
          if (playerStats.megaBall == 0) {
            if (balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x) >= ceil(balls[idx].x)) { bounceRight = 1;  }
            else { bounceLeft = 1; }
          }
        }
      }
    
      // Ball Y collision detection  
      if (balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y) >= PLAY_AREA_BOTTOM && idx == 0) { bounceDown = 1; }
      else if (balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y) <= PLAY_AREA_TOP) { bounceUp = 1; }
      else {
        brickHitY = isThereABrickHere(floor(balls[idx].x), floor(balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y)));
        if (brickHitY.x > -1) {
          if (playerStats.megaBall == 0) {  
            if (balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y) >= ceil(balls[idx].y)) { bounceDown = 1; }     
            else { bounceUp = 1; }
          }
        }   
      }
      
      // Are we hitting a brick directly in the corner?
      if (brickHitX.x == -1 && brickHitY.x == -1 && !bounceDown && !bounceUp && !bounceLeft && !bounceRight) { 
        brickHitX = isThereABrickHere(floor(balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x)), floor(balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y)));
        if (brickHitX.x > -1) {
          if (playerStats.megaBall == 0) {
            if ((balls[idx].xvelo * angles[balls[idx].angle].x) >= (balls[idx].yvelo * angles[balls[idx].angle].y)) {
              if (balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y) >= ceil(balls[idx].y)) { bounceDown = 1;  }     
              else { bounceUp = 1; }        
            }  
            else {
              if (balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x) >= ceil(balls[idx].x)) { bounceRight = 1;  }
              else { bounceLeft = 1; }
            }
          }
        }
      }
      
      // Ball collision with the bar
      if (balls[idx].y >= PLAYER_HEIGHT - 1 && balls[idx].y <= PLAY_AREA_BOTTOM - 1 && balls[idx].x >= playerStats.x && balls[idx].x < playerStats.x + playerStats.width && balls[idx].yvelo > 0) {
        bounceDown = 1;
        if (balls[idx].x >= playerStats.x + playerStats.width - 1 && balls[idx].xvelo >= 0) {
          changeBallAngle(-4, idx);     
        }  
        else if (balls[idx].x >= playerStats.x + playerStats.width - 1 && balls[idx].xvelo < 0) {
          changeBallAngle(4, idx);
        }
        else if (balls[idx].x >= playerStats.x + playerStats.width - 2 && balls[idx].xvelo >= 0) {
          changeBallAngle(-3, idx);     
        }  
        else if (balls[idx].x >= playerStats.x + playerStats.width - 2 && balls[idx].xvelo < 0) {
          changeBallAngle(3, idx);
        }
        else if (balls[idx].x >= playerStats.x + playerStats.width - 3 && balls[idx].xvelo >= 0) {
          changeBallAngle(-2, idx);     
        }  
        else if (balls[idx].x >= playerStats.x + playerStats.width - 3 && balls[idx].xvelo < 0) {
          changeBallAngle(2, idx);
        }
         else if (balls[idx].x >= playerStats.x + playerStats.width - 4 && balls[idx].xvelo >= 0) {
          changeBallAngle(-1, idx);     
        }  
        else if (balls[idx].x >= playerStats.x + playerStats.width - 4 && balls[idx].xvelo < 0) {
          changeBallAngle(1, idx);
        }
      }
   
  //    gb.display.cursorX = 34;
  //    gb.display.cursorY = 38;
  //    gb.display.print(bounceLeft);
  //    gb.display.print(bounceRight);
  //    gb.display.print(bounceUp);
  //    gb.display.print(bounceDown);
  //    gb.display.cursorX = 4;
  //    gb.display.cursorY = 32;
  //    gb.display.print(balls[idx].xvelo);
  //    gb.display.print(" "); 
  //    gb.display.print(balls[idx].yvelo);
    
      if (bounceRight) { 
        balls[idx].x = ceil(balls[idx].x) - (balls[idx].xvelo * angles[balls[idx].angle].x);
        balls[idx].xvelo = -abs(balls[idx].xvelo);
      }
      else if (bounceLeft) {
        balls[idx].x = floor(balls[idx].x) - (balls[idx].xvelo * angles[balls[idx].angle].x);
        balls[idx].xvelo = abs(balls[idx].xvelo);
      }
      
      if (bounceDown) {  
        balls[idx].y = ceil(balls[idx].y) - (balls[idx].yvelo * angles[balls[idx].angle].y);
        balls[idx].yvelo = -abs(balls[idx].yvelo);
      }
      else if (bounceUp) {
        balls[idx].y = floor(balls[idx].y) - (balls[idx].yvelo * angles[balls[idx].angle].y);
        balls[idx].yvelo = abs(balls[idx].yvelo);
      }
      
      if (bounceLeft || bounceRight || bounceUp || bounceDown) { gb.sound.playNote(40,1,0); }
  
      if (!bounceRight && !bounceLeft) { balls[idx].x = balls[idx].x + (balls[idx].xvelo * angles[balls[idx].angle].x); }
      if (!bounceUp && !bounceDown) { balls[idx].y = balls[idx].y + (balls[idx].yvelo * angles[balls[idx].angle].y); }
      
      byte ballXL;
      byte ballYU;
      
      if ((balls[idx].xvelo * angles[balls[idx].angle].x) >= 0) { ballXL = floor(balls[idx].x - 1); }
      else { ballXL = floor(balls[idx].x); }
      if ((balls[idx].yvelo * angles[balls[idx].angle].y) >= 0) { ballYU = floor(balls[idx].y - 1); }
      else { ballYU = floor(balls[idx].y); }
      
      gb.display.fillRect(ballXL, ballYU, 2, 2);
    
      if (playerStats.megaBall > 0 && frame == 1) {
        gb.display.drawLine(balls[idx].x + (balls[idx].xvelo * 4 * angles[balls[idx].angle].x),
                            balls[idx].y + (balls[idx].yvelo * 4 * angles[balls[idx].angle].y),
                            balls[idx].x - (balls[idx].xvelo * 8 * angles[balls[idx].angle].x),
                            balls[idx].y - (balls[idx].yvelo * 8 * angles[balls[idx].angle].y));
      }
      
      if (balls[idx].xvelo > 0) { balls[idx].xvelo = min(balls[idx].xvelo + ballAcceleration, MAX_VELO); }
      else { balls[idx].xvelo = max(balls[idx].xvelo - ballAcceleration, -MAX_VELO); }
      if (balls[idx].yvelo > 0) { balls[idx].yvelo = min(balls[idx].yvelo + ballAcceleration, MAX_VELO); }
      else { balls[idx].yvelo = max(balls[idx].yvelo - ballAcceleration, -MAX_VELO); }
      
      if (brickHitY.x > -1) {
        if (balls[idx].explode == 1) {
          brickExplosion(brickHitY, 2);
          spawnExplosion(balls[idx].x, balls[idx].y);
          balls[idx].explode = 0;
        }
        else { brickHit(brickHitY, playerStats.megaBall); }
      }
      if (brickHitX.x > -1) {
        if (balls[idx].explode == 1) {
          brickExplosion(brickHitX, 2);
          spawnExplosion(balls[idx].x, balls[idx].y);
          balls[idx].explode = 0;
        }
        else { brickHit(brickHitX, playerStats.megaBall); }
      }
    }
    if (playerStats.megaBall > 0) { playerStats.megaBall--; }
  }
}

// Draw the walls around the play field
void drawBorders() {
  for (byte idx = 0; idx < PLAY_AREA_BOTTOM; idx=idx+8) {
    gb.display.drawBitmap(0,idx,wall[frame], ROTCCW, NOFLIP);
    gb.display.drawBitmap(PLAY_AREA_RIGHT,idx,wall[frame],ROTCW,NOFLIP);    
  }
  for (byte idx = 2; idx < PLAY_AREA_RIGHT; idx=idx+8) {
    gb.display.drawBitmap(idx,0,wall[frame]);
  }
}

// Draw the bricks
void drawBricks() {
  for (byte x = 0; x < BRICKS_NB_WIDTH; x++) {
    for (byte y = 0; y < BRICKS_NB_HEIGHT; y++) {
      if (bricks[y][x] != 0) {
        switch (bricks[y][x]) {
          case 1:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick1[frame]);
            break;
          case 2:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick2[frame]);
            break;
          case 3:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick3[frame]);
            break;
          case 4:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick4[frame]);
            break;
          case 5:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick5[frame]);
            break;
          case 6:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick6[frame]);
            break;
          case 100:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick100[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 101:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick101[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 102:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick102[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 103:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick103[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 104:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick104[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 105:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick105[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 106:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick106[frame]);
            if (frame == 1) { bricks[y][x] = 100; }
            break;
          case 108:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick108[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 109:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick109[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 110:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick110[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 111:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick111[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 112:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick112[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 113:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick113[frame]);
            if (frame == 1) { bricks[y][x]++; }
            break;
          case 114:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick114[frame]);
            if (frame == 1) { bricks[y][x] = 108; }
            break;
          case -10:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break1[frame]);
            bricks[y][x]++;
            break;
          case -9:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break1[frame]);
            bricks[y][x]++;
            break;
          case -8:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break2[frame]);
            bricks[y][x]++;
            break;
          case -7:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break2[frame]);
            bricks[y][x]++;
            break;  
          case -6:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break3[frame]);
            bricks[y][x]++;
            break;  
          case -5:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break3[frame]);
            bricks[y][x]++;
            break;  
          case -4:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break4[frame]);
            bricks[y][x]++;
            break; 
          case -3:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break4[frame]);
            bricks[y][x]++;
            break;  
          case -2:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break5[frame]);
            bricks[y][x]++;
            break;
          case -1:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break5[frame]);
            bricks[y][x]++;
            break;              
          case -20:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break1[frame]);
            bricks[y][x] = 6;
            break;
          case -19:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break1[frame]);
            bricks[y][x]--;
            break;
          case -18:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break2[frame]);
            bricks[y][x]--;
            break;
          case -17:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break2[frame]);
            bricks[y][x]--;
            break;  
          case -16:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break3[frame]);
            bricks[y][x]--;
            break;  
          case -15:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break3[frame]);
            bricks[y][x]--;
            break;  
          case -14:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break4[frame]);
            bricks[y][x]--;
            break; 
          case -13:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break4[frame]);
            bricks[y][x]--;
            break;  
          case -12:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break5[frame]);
            bricks[y][x]--;
            break;
          case -11:
            gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, break5[frame]);
            bricks[y][x]--;
            break;
          case -21:
            if (frame == 1) {
              if (random(0,1000) == 0) { bricks[y][x] = -11; }
            }
            else { gb.display.drawBitmap((x*BRICK_WIDTH)+PLAY_AREA_LEFT, (y*BRICK_THICKNESS)+PLAY_AREA_TOP, brick6_21); }
            break;
        }
      }
    }
  }
}

void brickHit(cursorStruct idx, boolean powerfull) {
  byte bX;
  byte bY;
  switch (bricks[idx.y][idx.x]) {   
    case 1:
      bricks[idx.y][idx.x]=BREAK_ANIMATION_FRAME;
      break;
    case 2:
    case 3:
      if (powerfull) { bricks[idx.y][idx.x]=BREAK_ANIMATION_FRAME; }
      else { bricks[idx.y][idx.x]--; }
    case 5:
      if (powerfull) { bricks[idx.y][idx.x]=BREAK_ANIMATION_FRAME; }
      break;
    case 6:
      if (powerfull) { bricks[idx.y][idx.x]=BREAK_ANIMATION_FRAME; }
      else { bricks[idx.y][idx.x] = -21; }
      break;    
    case 4:
      bricks[idx.y][idx.x]=BREAK_ANIMATION_FRAME;
      bX = idx.x * BRICK_WIDTH + PLAY_AREA_LEFT + (BRICK_WIDTH / 2);
      bY = idx.y * BRICK_THICKNESS + PLAY_AREA_TOP + (BRICK_THICKNESS / 2);
      spawnItem(bX, bY);
      break;
    case 100:
    case 101:
    case 102:
    case 103:
    case 104:
    case 105:
    case 106:
      bricks[idx.y][idx.x] = BREAK_ANIMATION_FRAME;
      brickExplosion(idx, 2);
      bX = idx.x * BRICK_WIDTH + PLAY_AREA_LEFT + (BRICK_WIDTH / 2);
      bY = idx.y * BRICK_THICKNESS + PLAY_AREA_TOP + (BRICK_THICKNESS / 2);
      spawnExplosion(bX, bY);
      break;
    case 108:
    case 109:
    case 110:
    case 111:
    case 112:
    case 113:
    case 114:
      bricks[idx.y][idx.x] = BREAK_ANIMATION_FRAME;
      brickExplosion(idx, 1);
      bX = idx.x * BRICK_WIDTH + PLAY_AREA_LEFT + (BRICK_WIDTH / 2);
      bY = idx.y * BRICK_THICKNESS + PLAY_AREA_TOP + (BRICK_THICKNESS / 2);
      spawnExplosion(bX, bY);
      break;      
  }
}

cursorStruct isThereABrickHere(byte X, byte Y) {
  if (Y < (PLAY_AREA_TOP + (BRICKS_NB_HEIGHT * BRICK_THICKNESS))) {
    byte brickX = floor((X - PLAY_AREA_LEFT) / BRICK_WIDTH);
    byte brickY = floor((Y - PLAY_AREA_TOP) / BRICK_THICKNESS);
    if (bricks[brickY][brickX] > 0) { return (cursorStruct) { brickX, brickY }; }
  }
  return (cursorStruct) { -1, 0 };
}

void brickExplosion(cursorStruct idx, char power) {
  for (char bx = -power; bx <= power; bx++) {
    for (char by = -power; by <= power; by++) {
      if (idx.x + bx >= 0 && idx.x + bx < BRICKS_NB_WIDTH && idx.y + by >= 0 && idx.y + by < BRICKS_NB_HEIGHT) {
        if (random(11, (power*20)+2) > (abs(bx) + abs(by)) * 10) {
          brickHit((cursorStruct) { idx.x + bx, idx.y + by }, 1);
        }
      } 
    } 
  }
}

void spawnItem(byte X, byte Y) {
  /*
  7 - F = faster ball      5
  8 - S = slower ball      5
  6 - M = mega ball        2
  10- X = exploding ball   2
  3 - B = extra ball       5
  9 - W = warp ball        4
  
  1 - E = enlarge bar     15
  2 - C = chop bar        10
  
  4 - L = lasers           8
  5 - R = rockets          7 = 63
  */
  char itemPos = -1;
  for (byte idx = 0; idx < NB_ITEMS_MAX && itemPos == -1; idx++) {
    if (items[idx].type == -1) { itemPos = idx; }
  }
  if (itemPos != -1) {
    char it = random(0,63);
    items[itemPos].x = X;
    items[itemPos].y = Y;
    if      (it <  5) { items[itemPos].type = 7; }
    else if (it < 10) { items[itemPos].type = 8; }
    else if (it < 12) { items[itemPos].type = 6; }
    else if (it < 14) { items[itemPos].type = 10;}
    else if (it < 19) { items[itemPos].type = 3; }
    else if (it < 23) { items[itemPos].type = 9; }
    else if (it < 38) { items[itemPos].type = 1; }
    else if (it < 48) { items[itemPos].type = 2; }
    else if (it < 56) { items[itemPos].type = 4; }
    else              { items[itemPos].type = 5; }
  }
}

void moveItems() {
  for (byte idx = 0; idx < NB_ITEMS_MAX; idx++) {
    if (items[idx].type > -1) {
      if (frame == 1) { items[idx].y++; } 
      if (items[idx].y > PLAY_AREA_BOTTOM + 8) { items[idx].type = -1; }
      else if (items[idx].y >= PLAYER_HEIGHT - 1
            && items[idx].y < PLAY_AREA_BOTTOM 
            && items[idx].x >= playerStats.x + PLAY_AREA_LEFT
            && items[idx].x < playerStats.x + PLAY_AREA_LEFT + playerStats.width) {
        switch(items[idx].type) {
          case 1:
            if (playerStats.width < BAR_MAX_WIDTH) { playerStats.width++; }
            break;
          case 2:
            if (playerStats.width > BAR_MIN_WIDTH) { playerStats.width = max(playerStats.width - 2, BAR_MIN_WIDTH); }
            break;
          case 3:
            spawnBall((ballStruct){0,0,0,0,0}, 1);
            break;
          case 4:
            playerStats.lasers = min(playerStats.lasers + NB_LASERS_PER_ITEM, NB_LASERS_MAX);
            break;
          case 5:
            playerStats.rockets = min(playerStats.rockets + 1, NB_ROCKETS_MAX);
            break;
          case 6:
            playerStats.megaBall += (115 - (15 * countBalls()));
            break;
          case 7:
           for (byte id = 0; id < NB_BALLS_MAX; id++) {
              if (balls[id].x > -1) {
                if (balls[id].xvelo >= 0) { balls[id].xvelo = min(balls[id].xvelo + BALL_VELO_ITEM_MOD, MAX_VELO); }
                else { balls[id].xvelo = max(balls[id].xvelo - BALL_VELO_ITEM_MOD, -MAX_VELO); }
                if (balls[id].yvelo >= 0) { balls[id].yvelo = min(balls[id].yvelo + BALL_VELO_ITEM_MOD, MAX_VELO); }
                else { balls[id].yvelo = max(balls[id].yvelo - BALL_VELO_ITEM_MOD, -MAX_VELO); } 
              } 
            }
            break;
          case 8:
            for (byte id = 0; id < NB_BALLS_MAX; id++) {
              if (balls[id].x > -1) {
                if (balls[id].xvelo <= 0) { balls[id].xvelo = min(balls[id].xvelo + BALL_VELO_ITEM_MOD, -MIN_VELO); }
                else { balls[id].xvelo = max(balls[id].xvelo - BALL_VELO_ITEM_MOD, MIN_VELO); }     
                if (balls[id].yvelo <= 0) { balls[id].yvelo = min(balls[id].xvelo + BALL_VELO_ITEM_MOD, -MIN_VELO); }
                else { balls[id].yvelo = max(balls[id].xvelo - BALL_VELO_ITEM_MOD, MIN_VELO); } 
              } 
            }           
            break;
          case 9:
            for (byte id = 0; id < NB_BALLS_MAX; id++) {
              if (balls[id].x > -1) {
                balls[id].yvelo = -abs(balls[id].yvelo);
                char tmpWarp = 0;
                while (isThereABrickHere(balls[id].x, balls[id].y + tmpWarp).x == -1 && balls[id].y + tmpWarp > PLAY_AREA_TOP) {
                  tmpWarp--; 
                }
                gb.display.drawLine(balls[id].x,balls[id].y,balls[id].x,balls[id].y + tmpWarp + 1);
                balls[id].y = balls[id].y + tmpWarp + 1;

              }
            }
            break;
          case 10:
            for (byte id = 0; id < countBalls(); id++) {
              if (balls[id].x > -1) { balls[id].explode = 1; }
            }            
            break;          
        }      
        items[idx].type = -1;
      }
      else {
        gb.display.cursorX = items[idx].x-2;
        gb.display.cursorY = items[idx].y;
        switch(items[idx].type) {
          case 1:
            gb.display.print(F("E"));
            break;
          case 2:
            gb.display.print(F("C"));
            break;
          case 3:
            gb.display.print(F("B"));
            break;
          case 4:
            gb.display.print(F("L"));
            break;
          case 5:
            gb.display.print(F("R"));
            break;
          case 6:
            gb.display.print(F("M"));
            break;
          case 7:
            gb.display.print(F("F"));
            break;
          case 8:
            gb.display.print(F("S"));
            break;
          case 9:
            gb.display.print(F("W"));
            break;          
          case 10:
            gb.display.print(F("X"));
            break;                      
        }        
      }
    }  
  }
}

void movePlayer() {
  if(gb.buttons.repeat(BTN_RIGHT,1)) { playerStats.xvelo = max(playerStats.xvelo + 0.5, 1); }
  else if (gb.buttons.repeat(BTN_LEFT,1)) { playerStats.xvelo = min(playerStats.xvelo - 0.5, -1); }
  else { playerStats.xvelo = 0; }

  if (playerStats.x + playerStats.xvelo < PLAY_AREA_LEFT) { playerStats.x = PLAY_AREA_LEFT; playerStats.xvelo = 0; }
  else if (playerStats.x + playerStats.xvelo > PLAY_AREA_RIGHT - playerStats.width) { playerStats.x = PLAY_AREA_RIGHT - playerStats.width; playerStats.xvelo = 0; }
  else { playerStats.x += playerStats.xvelo; }
  
  gb.display.drawBitmap(floor(playerStats.x),PLAYER_HEIGHT,barSide[frame]); 
  gb.display.drawBitmap(floor(playerStats.x)+playerStats.width-9,PLAYER_HEIGHT,barSide[frame],NOROT,FLIPH);
  if (playerStats.width > 16 && playerStats.width < 20) {
    gb.display.drawBitmap(floor(floor(playerStats.x)+3),PLAYER_HEIGHT,barMid[frame]);
  }
  else if (playerStats.width >= 20) {
    gb.display.drawBitmap(floor(floor(playerStats.x)+8),PLAYER_HEIGHT,barMid[frame]);
  }
}

void launchRocket() {
  boolean done = 0;
  for (byte idx = 0; idx < NB_ROCKETS_SIMULTANEOUS_MAX && !done; idx++) {
    if (rockets[idx].x == -1 && playerStats.rockets > 0) {
      rockets[idx].x = playerStats.x + (playerStats.width / 2);
      rockets[idx].y = PLAYER_HEIGHT;
      playerStats.rockets--;
      done++;
    }
  } 
}

void shootLasers() {
  char laser1 = -1;
  char laser2 = -1;
  for (byte idx = 0; idx < NB_LASERS_SIMULTANEOUS_MAX && (laser1 == -1 || laser2 == -1); idx++) {
    if (lasers[idx].x == -1 && laser1 == -1) { laser1 = idx; }
    else if (lasers[idx].x == -1 && laser2 == -1)  { laser2 = idx; }
  }
  if (laser1 > -1 && laser2 > -1 && playerStats.lasers >= 2) {
    lasers[laser1].x = playerStats.x + 2; 
    lasers[laser1].y = PLAYER_HEIGHT; 
    lasers[laser2].x = playerStats.x + playerStats.width - 3;
    lasers[laser2].y = PLAYER_HEIGHT;  
    playerStats.lasers = max(playerStats.lasers - 2, 0);
  }
}

void moveLasers() {
  for (byte idx = 0; idx < NB_LASERS_SIMULTANEOUS_MAX; idx++) {
    if (lasers[idx].x > -1) { 
      lasers[idx].y--;
      cursorStruct hit = isThereABrickHere(lasers[idx].x, lasers[idx].y);
      if (hit.x > -1) { brickHit(hit,0); lasers[idx].x = -1; }
      else if (lasers[idx].y < PLAY_AREA_TOP) { lasers[idx].x = -1; }
     }
  }  
  for (byte idx = 0; idx < NB_LASERS_SIMULTANEOUS_MAX; idx++) {
    if (lasers[idx].x > -1) { gb.display.drawLine(lasers[idx].x, lasers[idx].y, lasers[idx].x, min(lasers[idx].y + 2, PLAYER_HEIGHT)); }
  }
}

void moveRockets() {
  for (byte idx = 0; idx < NB_ROCKETS_SIMULTANEOUS_MAX; idx++) {
    if (rockets[idx].x > -1) {
      if (frame == 1) { rockets[idx].y--; }
      cursorStruct hit = isThereABrickHere(rockets[idx].x, rockets[idx].y);
      if (hit.x > -1) { 
        brickExplosion(hit, 2);
        spawnExplosion(rockets[idx].x + 1, rockets[idx].y); 
        rockets[idx].x = -1;
      }
      else if (rockets[idx].y < PLAY_AREA_TOP) { 
        brickExplosion((cursorStruct) { floor((rockets[idx].x-PLAY_AREA_LEFT) / BRICK_WIDTH), 0 }, 2);
        spawnExplosion(rockets[idx].x + 1, rockets[idx].y);
        rockets[idx].x = -1;
      }
    }
  }
  for (byte idx = 0; idx < NB_ROCKETS_SIMULTANEOUS_MAX; idx++) {
    if (rockets[idx].x > -1) { gb.display.drawBitmap(rockets[idx].x-1, rockets[idx].y, rocket[frame], ROTCW, NOFLIP); }
  } 
}

void changeBallAngle(char increment, char id) {
  balls[id].angle = max(min(balls[id].angle + increment, NB_ANGLES - 1),0);
}

void displayStatus(boolean all) {
  if (playerStats.rockets > 0 || all) {
    gb.display.cursorX = STATUS_POS_X;
    gb.display.cursorY = STATUS_POS_Y;
    gb.display.print("R: ");
    gb.display.print(playerStats.rockets);
  }
  if (playerStats.lasers > 0 || all) {
    gb.display.cursorX = STATUS_POS_X;
    gb.display.cursorY = STATUS_POS_Y+6;
    gb.display.print("L:");
    if (playerStats.lasers < 10) { gb.display.print(" "); }
    gb.display.print(playerStats.lasers);
  }
}

void spawnExplosion(char x, char y) {
  char explosionFound = -1;
  byte explosionFoundDuration = 255;
  for (byte idx = 0; idx < NB_EXPLOSIONS_MAX; idx++) {
    if (explosions[idx].duration < explosionFoundDuration) {
      explosionFound = idx;
      explosionFoundDuration = explosions[idx].duration;
    }
  }
  if (explosionFound > -1) {
    explosions[explosionFound].x = x-8;
    explosions[explosionFound].y = y-6;
    explosions[explosionFound].duration = EXPLOSIONS_DURATION;
  }
}

void drawExplosions() {
  for (byte idx = 0; idx < NB_EXPLOSIONS_MAX; idx++) {
    if (explosions[idx].x != -99) {
      gb.display.drawBitmap(explosions[idx].x, explosions[idx].y, explosion, random(0,4), random(0,3));
      explosions[idx].duration--;
      if (explosions[idx].duration < 1) { explosions[idx].x = -99; }
      if (frame == 1) { gb.sound.playNote(0,1,0); }
    }
  }
}

// Count the number of bricks
byte countBricks(char type = 0) {
  byte nbBricks = 0;
  for (byte x = 0; x < BRICKS_NB_WIDTH; x++) { 
    for (byte y = 0; y < BRICKS_NB_HEIGHT; y++) {
      if (type > 0) { if (bricks[y][x] == type) { nbBricks++; } }
      else { if (bricks[y][x] > 0 && bricks[y][x] != 5) { nbBricks++; } }
    }
  }
  return nbBricks;
}

void setup() {
  randomSeed(gb.battery.voltage + gb.backlight.ambientLight + 4);
  gb.begin();
  gb.titleScreen(F("Bricks! by Drakker"), logo);
  
  gb.battery.show = false;
  gb.setFrameRate(41);
  gb.display.setFont(font3x5);
  
  // Bunch of pointers to existing tiles to allow easy switching of tile
  // based on the current frame, used for gray.
  wall[0] = picWall1;
  wall[1] = picWall2;
  
  brick1[0] = brick1_1;
  brick1[1] = brick1_2;

  brick2[0] = brick2_1;
  brick2[1] = brick2_2;
  
  brick3[0] = brick3_1;
  brick3[1] = brick3_2;

  brick4[0] = brick4_1;
  brick4[1] = brick4_2;

  brick5[0] = brick5_1;
  brick5[1] = brick5_2;
  
  brick6[0] = brick1_1;
  brick6[1] = brick6_2;

  // Brick bomb animation
  brick100[0] = brickBomb_1;
  brick100[1] = brickBomb_1;
  brick101[0] = brickBomb_1;
  brick101[1] = brickBomb_2;
  brick102[0] = brickBomb_2;
  brick102[1] = brickBomb_3;
  brick103[0] = brickBomb_3;
  brick103[1] = brickBomb_4;
  brick104[0] = brickBomb_3;
  brick104[1] = brickBomb_4;
  brick105[0] = brickBomb_3;
  brick105[1] = brickBomb_3;
  brick106[0] = brickBomb_2;
  brick106[1] = brickBomb_2;
  // End of brick bomb animation

  // Brick mine animation
  brick108[0] = brickMine_1;
  brick108[1] = brickMine_1;
  brick109[0] = brickMine_1;
  brick109[1] = brickMine_2;
  brick110[0] = brickMine_2;
  brick110[1] = brickMine_3;
  brick111[0] = brickMine_3;
  brick111[1] = brickMine_4;
  brick112[0] = brickMine_3;
  brick112[1] = brickMine_4;
  brick113[0] = brickMine_3;
  brick113[1] = brickMine_3;
  brick114[0] = brickMine_2;
  brick114[1] = brickMine_2;
  // End of brick bomb animation
  
  // Break Animation
  break1[0] = break1_1;
  break1[1] = break1_2;
  break2[0] = break1_1;
  break2[1] = break2_2;
  break3[0] = break1_1;
  break3[1] = break3_2;
  break4[0] = break4_1;
  break4[1] = break4_2;   
  break5[0] = break4_1;
  break5[1] = break5_2;   
  // Break animation ends here

  barSide[0] = barSide1;
  barSide[1] = barSide2;   
  barMid[0] = barMid1;
  barMid[1] = barMid2; 

  rocket[0] = rocketSprite1;
  rocket[1] = rocketSprite2;  
  
  spawnBall((ballStruct){42, PLAYER_HEIGHT, 0.65, -0.65, 8});
}

void loop() {
  if (gb.update()) {
    frame = bitRead(gb.frameCount, 0);
    if (gb.buttons.pressed(BTN_C)) { pause = !pause; }
    if (!pause) {
      if (frame == 0) { displayStatus(0); }
      if (gb.buttons.pressed(BTN_B)) { shootLasers(); }
      if (gb.buttons.pressed(BTN_A)) { launchRocket(); }
      if (gb.buttons.pressed(BTN_UP)) { playerStats.width = min(playerStats.width + 1, BAR_MAX_WIDTH); }
      if (gb.buttons.pressed(BTN_DOWN)) { playerStats.width = max(playerStats.width - 1, BAR_MIN_WIDTH); }
      moveItems();
      moveLasers();
      moveRockets();
      drawBorders();
      drawBricks();
      moveBalls();
      movePlayer();
      drawExplosions();
//      if (frame == 1) {
//        gb.display.cursorX = 4;
//        gb.display.cursorY = STATUS_POS_Y;
//        gb.display.print(countBalls());
//      }

//      void * heap_ptr = malloc(0);  
//      if ((!heap_ptr) || ((int)heap_ptr + 100 >= SP)) {
//        Serial.println("Out of memory!");
//        while (1);
//      }
//      free(heap_ptr);
    }
    else {
      gb.display.cursorX = 28;
      gb.display.cursorY = 12;
      gb.display.print("BRICKS!");
      gb.display.cursorX = 29;
      gb.display.cursorY = 22;
      gb.display.print("PAUSED");
      displayStatus(1);
      drawBorders();     
    }
  }
}




